Building Shops HDU - 6024(动态规划)

HDU’s n classrooms are on a line ,which can be considered as a number line. Each classroom has a coordinate. Now Little Q wants to build several candy shops in these n classrooms.

The total cost consists of two parts. Building a candy shop at classroom i would have some cost ci. For every classroom P without any candy shop, then the distance between P and the rightmost classroom with a candy shop on P’s left side would be included in the cost too. Obviously, if there is a classroom without any candy shop, there must be a candy shop on its left side.

Now Little Q wants to know how to build the candy shops with the minimal cost. Please write a program to help him.
Input
The input contains several test cases, no more than 10 test cases.
In each test case, the first line contains an integer n(1≤n≤3000), denoting the number of the classrooms.
In the following n lines, each line contains two integers xi,ci(−109≤xi,ci≤109), denoting the coordinate of the i-th classroom and the cost of building a candy shop in it.
There are no two classrooms having same coordinate.
Output
For each test case, print a single line containing an integer, denoting the minimal cost.
Sample Input
3
1 2
2 3
3 4
4
1 7
3 1
5 10
6 1
Sample Output
5
11
题意:有n个位置有可能建立糖果店,最左边的位置一定建立糖果店,后面的位置如果建立糖果店,花费就是建立糖果店的花费,如果不建立糖果店,花费就是到左边最靠近它的糖果店的距离。问最小花费是多少。
思路:当前是否建立糖果店对结果是有后效性的,因此需要考虑动态规划。如果当前需要建立糖果店,那么就在前一个点是否建立糖果店的代价中取一个最小的。如果不需要建立糖果店,就在前面找一个建立糖果店的点,再加上距离花费就可以。
在这里插入图片描述
如图所示:假如4不建立糖果店,它现在找到了1,1是建立糖果店的。那么距离怎么算?我们可以发现,1-2的距离是计算了3次,2-3是两次,3-4是1次。次数分别是4-1,4-2,4-3.规律就很明显了。
状态转移方程:
在这里插入图片描述
代码如下:

#include<bits/stdc++.h>
#define ll long long
#define inf 0x3f3f3f3f
using namespace std;

const int maxx=3e3+100;
struct node{
	int x;ll val;
	bool operator<(const node &a)const{
		return x<a.x;
	}
}p[maxx];
ll dp[maxx][2];
int n;

int main()
{
	while(~scanf("%d",&n))
	{
		for(int i=1;i<=n;i++) scanf("%d%lld",&p[i].x,&p[i].val);
		memset(dp,inf,sizeof(dp));
		sort(p+1,p+1+n);
		dp[1][1]=p[1].val;
		dp[1][0]=inf;
		for(int i=2;i<=n;i++)
		{
			dp[i][1]=min(dp[i-1][1],dp[i-1][0])+p[i].val;
			ll dis=0;
			for(int j=i-1;j>=1;j--)
			{
				dis=dis+(ll)(i-j)*(p[j+1].x-p[j].x);//这里一定要用long long。
				dp[i][0]=min(dp[i][0],dp[j][1]+dis);
			}
		}
		printf("%lld\n",min(dp[n][1],dp[n][0]));
	}
	return 0;
}

努力加油a啊,(o)/~

发布了652 篇原创文章 · 获赞 101 · 访问量 5万+

猜你喜欢

转载自blog.csdn.net/starlet_kiss/article/details/105447494